
TYPO3.Fluid - Bug # 45735

Status: Resolved Priority: Must have
Author: Alex no-lastname-given Category: Core
Created: 2013-02-22 Assigned To: Bastian Waidelich
Updated: 2015-06-30 Due date:
Has patch: No
Affected Flow version: Flow 2.0.0 beta 1
Subject: Error when using If-Condition in Layout-Tag
Description

I use a condition for evaluating which layout to load:

<f:layout name="{f:if(condition: checkCondition, then: 'Layout1', else: 'Layout2')}"/>

On the first request (template is not cached) it works fine, but on the second requets (template is loaded from cache) following error is
thrown:

#1: Notice: Undefined variable: self in
/Data/Temporary/Development/Cache/Code/Fluid_TemplateCache/PACKAGE_CONTROLLER_action_ACTION_20bd4ce9d92ee470c3edcf16e49b6ebec6252766.php line 1
ee470c3edcf16e49b6ebec6252766.php line 16 

This error can be fixed by adding a single line in store() of class TemplateCompiler
(TYPO3.Fluid\Classes\TYPO3\Fluid\Core\Compiler\TemplateCompiler.php). The template code ($templateCode) have to be
enhanced in the first line of getLayoutName() by

\$self = \$this;

To clarify, the final template code:

$templateCode = <<<EOD
%s {

public function getVariableContainer() {
    // TODO
    return new \TYPO3\Fluid\Core\ViewHelper\TemplateVariableContainer();
}
public function getLayoutName(\TYPO3\Fluid\Core\Rendering\RenderingContextInterface \$renderingContext) {
\$self = \$this;
%s
return %s;
}
public function hasLayout() {
return %s;
}

%s
}
EOD;

Associated revisions
Revision 4d167279 - 2014-06-23 11:59 - Bastian Waidelich

[BUGFIX] Support for ViewHelper usage within layout tags

Previously, when using ViewHelpers in the ``name`` argument of the
``<f:layout />`` tag, the TemplateCompiler threw an exception
``Notice: Undefined variable: self...`` when rendering the compiled
template.

This change fixes this by adding the respective initialization code
before the closure that makes use of ``$self``.

Change-Id: Ie45c92125a8a1f6b1fa0c5e4a5369486361c9c7c
Fixes: #45735
Releases: master, 2.2, 2.1

Revision b79dabb1 - 2014-06-23 13:48 - Bastian Waidelich

[BUGFIX] Support for ViewHelper usage within layout tags

Previously, when using ViewHelpers in the ``name`` argument of the
``<f:layout />`` tag, the TemplateCompiler threw an exception
``Notice: Undefined variable: self...`` when rendering the compiled
template.

This change fixes this by adding the respective initialization code
before the closure that makes use of ``$self``.

Change-Id: Ie45c92125a8a1f6b1fa0c5e4a5369486361c9c7c
Fixes: #45735
Releases: master, 2.2, 2.1

Revision 7a06d525 - 2015-06-30 11:22 - Bastian Waidelich

[BUGFIX] Support for ViewHelper usage within layout tags

Previously, when using ViewHelpers in the ``name`` argument of the
``<f:layout />`` tag, the TemplateCompiler threw an exception
``Notice: Undefined variable: self...`` when rendering the compiled
template.

This change fixes this by adding the respective initialization code
before the closure that makes use of ``$self``.
Change-Id: Ie45c92125a8a1f6b1fa0c5e4a5369486361c9c7c
Fixes: #45735
Releases: master, 2.2, 2.1

History
#1 - 2013-08-23 08:27 - Adrian Föder
- Status changed from New to Needs Feedback

alex, is this still present?

#2 - 2014-06-20 14:14 - Sebastian Düvel

I have the same problem, so yes, it's still present.

#3 - 2014-06-23 10:29 - Bastian Waidelich
- Status changed from Needs Feedback to Accepted
- Assigned To set to Bastian Waidelich
- Has patch changed from Yes to No

#4 - 2014-06-23 11:15 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at https://review.typo3.org/31065

#5 - 2014-06-23 11:59 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at https://review.typo3.org/31065

#6 - 2014-06-23 13:48 - Gerrit Code Review

Patch set 1 for branch 2.2 of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at https://review.typo3.org/31067

#7 - 2014-06-23 13:48 - Gerrit Code Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at https://review.typo3.org/31068

#8 - 2014-06-23 14:37 - Bastian Waidelich
- Status changed from Under Review to Resolved
Applied in changeset commit:4d1672792d523a457b48bd009ab01f0ce7702b29.

#9 - 2015-06-30 11:22 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch 2.1 of project Packages/TYPO3.Fluid has been pushed to the review server.
It is available at http://review.typo3.org/31068

#10 - 2015-06-30 11:39 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:7a06d5252f4ab38751a467bd7fa75cff45b2b003.
